package.loaded.Constants = nil; require("Constants");
function CleanFloor:StartActivity()
	PresetMan:ReloadAllScripts();
	self.MapPick = SceneMan.Scene:GetArea("Blank");
	self.startingActor = "Brain Robot";
	self.music = "Base.rte/Music/dBSoundworks/ccambient4.ogg";
	self.deliveryRestraints = false;
-- 	Brain Locations
	self.startPos = Vector(5563, 585); -- Material Map + Material Map Empty
--	self.startPos = Vector(8145, 585); -- Material Map Empty Expanded

--	I used Calibri Font with size 36
-- Material must be 256 x 256 size if you want to make your own

	for player = 0, self.PlayerCount - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
			local team = self:GetTeamOfPlayer(player);
			if self.Player == nil then
				self.Player = player;
			end
			if not self:GetPlayerBrain(player) then
				local brain = CreateAHuman(self.startingActor);
				brain.Pos = self.startPos + Vector(player * 24, 0);
				brain.HFlipped = true;
				brain.Team = team;
				brain.AIMode = Actor.AIMODE_SENTRY;
				
				MovableMan:AddActor(brain);
				brain:AddInventoryItem(CreateHDFirearm("Assault Rifle"));
				
				self:SetPlayerBrain(brain, player);
				SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
				self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				--self:SwitchToActor(brain, player, team);
			end
        end
    end
	if self.Player == nil then
		self.Player = Activity.PLAYER_1;
	end
	self.PlayerTeam = self:GetTeamOfPlayer(self.Player);
	if not MATIntroMessage then
		ConsoleMan:PrintString("     ");
		ConsoleMan:PrintString("     WELCOME TO BEBO'S");
		ConsoleMan:PrintString("     (MATERIAL MAP)");
		ConsoleMan:PrintString("     ");
		self:GetBanner(GUIBanner.YELLOW, self.Player):ShowText("WELCOME TO", GUIBanner.FLYBYLEFTWARD, 1000, Vector(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight), 0.4, 2000, 0);
		self:GetBanner(GUIBanner.RED, self.Player):ShowText("MATERIAL MAP", GUIBanner.FLYBYRIGHTWARD, 1000, Vector(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight), 0.6, 2000, 0);
		MATIntroMessage = true;
	else
		self:GetBanner(GUIBanner.YELLOW, 0):ShowText("RESET", GUIBanner.FLYBYLEFTWARD, 500, Vector(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight), 0.5, 2000, 0);
	end
	AudioMan:ClearMusicQueue();
	AudioMan:PlayMusic(self.music, 2, -1.0);

	autoclear = true;

	self.weaponList = {};
	MATActorList = {};

	local module = PresetMan:GetModuleID(self:GetTeamTech(self.PlayerTeam));
	
	for module in PresetMan.Modules do
		for entity in module.Presets do
			if IsHeldDevice(entity)
			and ToHeldDevice(entity).IsBuyable
			then
				table.insert(self.weaponList, entity);
			elseif (entity.ClassName == "AHuman" or entity.ClassName == "ACrab")
			and ToActor(entity).IsBuyable
			then
				table.insert(MATActorList, entity);
				if not ActorToSpawn and entity.PresetName == "Green Dummy" then
					ActorToSpawn = #MATActorList;
				end
			end
		end
	end
	if not self.deliveryRestraints then
		self.DeliveryDelay = 0;
		self:GetBuyGUI(self.Player).EnforceMaxPassengersConstraint = false;
		self:GetBuyGUI(self.Player).EnforceMaxMassConstraint = false;
	end
	
	ActorToSpawn = ActorToSpawn and ActorToSpawn or 5;

	self:SetLandingZone(SceneMan:MovePointToGround(Vector(5415, 0), 0, 1), self.Player); -- Material Map + Material Map Empty
--	self:SetLandingZone(SceneMan:MovePointToGround(Vector(8025, 0), 0, 1), self.Player); -- Material Map Empty Expanded
	self:CreateDelivery(self.Player);

	self.playerTech = PresetMan:GetModuleID(self:GetTeamTech(Activity.TEAM_1));
	self.CPUTech = PresetMan:GetModuleID(self:GetTeamTech(Activity.TEAM_2));

	self.MOIDLimit = rte.MOIDCountMax;
	self.RespawnTimer = Timer();
	self.PlayerGold = 1000000;	--one million dollars
   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerScreen = self:ScreenOfPlayer(self.Player);
	self.SpawnInterval = 5.0;

	local guard = CreateAHuman("Commander");
	local item;
	guard:SetNumberValue("Identity", self.Player);
	guard:AddInventoryItem(CreateHDFirearm("Assault Rifle"));
-- 	Ronin Commander Location
	guard.Pos = Vector(5290, 585); -- Material Map + Material Map Empty
--	guard.Pos = Vector(7890, 585); -- Material Map Empty Expanded
	guard.Team = self.PlayerTeam;
-- 	guard.HFlipped = true;
	MovableMan:AddActor(guard);
end

function CleanFloor:UpdateActivity()

	if self.RespawnTimer:IsPastSimMS(1000 * self.SpawnInterval) and MovableMan:GetMOIDCount() <= self.MOIDLimit then
		self:CheckRespawn();
		self.RespawnTimer:Reset();
	end
	self:DoBrainSelection();

end

function CleanFloor:PauseActivity(pause)
end

function CleanFloor:EndActivity()
end

function CleanFloor:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if MovableMan:IsActor(brain) then
			elseif not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then

				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
					self:GetBanner(GUIBanner.RED, player):ClearText();
				else
					local brain = CreateAHuman("Base.rte/Brain Robot");
					brain.Pos = self.startPos;
					brain:AddInventoryItem(RandomHDFirearm("Weapons - Light", self.playerTech));
					brain:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.playerTech));
					brain:AddInventoryItem(RandomTDExplosive("Bombs - Grenades", self.playerTech));
					brain.AIMode = Actor.AIMODE_SENTRY;

       					MovableMan:AddActor(brain);
          				self:SetPlayerBrain(brain, player);
					SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
					self:SwitchToActor(brain, player, self.PlayerTeam);
				end
			end
		end
	end
end

function CleanFloor:CheckRespawn()
	if autoclear then
		cleararea = true;
	end
	local spawnItems = {HDF, HD, TDE, TD};
	for item in MovableMan.Items do
		for _, name in pairs(spawnItems) do
			if name and item.PresetName == name then
				item.ToDelete = true;
			end
		end
	end
end 